package com.example.demo.controller;

import com.example.demo.model.dto.*;
import com.example.demo.model.req.*;
import com.example.demo.proxy.AvataProxy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Created by:   zhulei
 * 2022/6/1 13:55
 * code is far away from bug with the animal protecting
 * <p>
 * <p>
 * █████▒█    ██  ▄████▄   ██ ▄█▀       ██████╗ ██╗   ██╗ ██████╗
 * ▓██   ▒ ██  ▓██▒▒██▀ ▀█   ██▄█▒        ██╔══██╗██║   ██║██╔════╝
 * ▒████ ░▓██  ▒██░▒▓█    ▄ ▓███▄░        ██████╔╝██║   ██║██║  ███╗
 * ░▓█▒  ░▓▓█  ░██░▒▓▓▄ ▄██▒▓██ █▄        ██╔══██╗██║   ██║██║   ██║
 * ░▒█░   ▒▒█████▓ ▒ ▓███▀ ░▒██▒ █▄       ██████╔╝╚██████╔╝╚██████╔╝
 * ▒ ░   ░▒▓▒ ▒ ▒ ░ ░▒ ▒  ░▒ ▒▒ ▓▒       ╚═════╝  ╚═════╝  ╚═════╝
 * ░     ░░▒░ ░ ░   ░  ▒   ░ ░▒ ▒░
 * ░ ░    ░░░ ░ ░ ░        ░ ░░ ░
 * ░     ░ ░      ░  ░
 * ░
 */
@Slf4j
@RestController
@RequestMapping("customNFT")
public class CustomNFTController {
    @Autowired
    AvataProxy avataProxy;

    @RequestMapping("/createAccount")
    public CreateAccountDTO createAccount(String name, String operationId) throws Exception {
        CreateAccountDTO account = avataProxy.createAccount( name, operationId );

        return account;
    }
//    @RequestMapping("/selectAccount")
//    public void selectAccount(String acc,String operationId) throws Exception {
//        AccReq accReq = new AccReq(  );
//        accReq.setAccount( acc );
//        accReq.setOperation_id( operationId );
//         avataProxy.SELECT_ACCOUNTS( accReq);
//
////        return account;
//    }

    //发行
    @RequestMapping("/createNft")
    public NFTOperateDTO createNft(String classId, String name, String operationId,String recipient) throws Exception {
        NFTPublishReq nftPublishReq = new NFTPublishReq();

        nftPublishReq.setClass_id( classId );
        nftPublishReq.setName( name );
        nftPublishReq.setOperation_id( operationId );
        nftPublishReq.setRecipient( recipient );

        NFTOperateDTO nftOperateDTO = avataProxy.publishNFT( nftPublishReq );
        return nftOperateDTO;
    }

    //发行
    @RequestMapping("/sNFT")
    public SNFTDTO sNFT(String classId, String NFTId) throws Exception {
        NFTTransferReq nftTransferReq  = new NFTTransferReq(  );

        nftTransferReq.setClass_id( classId );
        nftTransferReq.setNft_id( NFTId );//nftId


        SNFTDTO snftdto = avataProxy.sNFT( nftTransferReq );
        return snftdto;
    }

    //上架
    @RequestMapping("/setNftTypes")
    public NFTOperateDTO setNftTypes(String name, String owner, String operationId) {
        NFTCreateReq nftClassListReq = new NFTCreateReq();
        nftClassListReq.setName( name );
//        nftClassListReq.setClass_id( classId );
        nftClassListReq.setOwner( owner );
        nftClassListReq.setOperation_id( operationId );
//        nftClassListReq.setUri( tokeUri );
        NFTOperateDTO nftClassListDTO = avataProxy.createNFT( nftClassListReq );
        return nftClassListDTO;
    }

    //查询回执
    @RequestMapping("/queryDealResult")
    public DealResultDTO queryDealResult(String operationId) {
        DealResultDTO dealResultDTO = avataProxy.queryDealResult( operationId );
        return dealResultDTO;
    }

    //
    //转让NFT
    @RequestMapping("/transfer")
    public NFTOperateDTO transfer(String classId,String NFTId,String operationId,String owner,
                                  String recipient) {
        NFTTransferReq nftTransferReq  = new NFTTransferReq(  );
        nftTransferReq.setClass_id( classId );//NFT 类别 ID
        nftTransferReq.setNft_id( NFTId );//NFT ID
        nftTransferReq.setOperation_id( operationId );//操作 ID
        nftTransferReq.setOwner( owner );//NFT 持有者地址
        nftTransferReq.setRecipient( recipient );//NFT 接收者地址
        NFTOperateDTO nftOperateDTO = avataProxy.transferNFT( nftTransferReq );
        return nftOperateDTO;
    }
}
