package com.example.demo.model.dto;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;

/**
 * @author enlai.wang 16621134798
 * @date: 2022/5/26
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DealResultDTO {
    /**
     * 用户操作类型
     */
    private String type;

    /**
     * 交易hash
     */
    private String tx_hash;

    /**
     * 交易状态, 0 处理中; 1 成功; 2 失败; 3 未处理
     */
    private Integer status;

    /**
     * 类别id
     */
    private String class_id;

    /**
     * NFT ID
     */
    private String nft_id;

    /**
     * 错误描述
     */
    private String message;

    /**
     * 交易上链的区块高度
     */
    private String block_height;

    /**
     * 交易标签, 自定义 key：支持大小写英文字母和汉字和数字，长度6-12位，自定义 value：长度限制在64位字符，支持大小写字母和数字
     */
    private Map<String, Object> tag;
}
