package com.example.demo.model.req;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author enlai.wang 16621134798
 * @date: 2022/5/26
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class NFTClassListReq {
    /**
     * 游标，默认0
     */
    private String offset;

    /**
     * 每页数量
     */
    private String limit;

    /**
     * NFT类别ID
     */
    private String id;

    /**
     * NFT类别名称
     */
    private String name;

    /**
     * NFT类别权属者地址
     */
    private String owner;

    /**
     * 创建 NFT 类别的 Tx Hash
     */
    private String tx_hash;

    /**
     * NFT 类别创建日期范围 - 开始，yyyy-MM-dd（UTC 时间）
     */
    private String start_date;

    /**
     * NFT 类别创建日期范围 - 结束，yyyy-MM-dd（UTC 时间）
     */
    private String end_date;

    /**
     * 排序规则：DATE_ASC / DATE_DESC
     */
    private String sort_by;
}
