package com.example.demo;

import com.example.demo.model.dto.CreateAccountDTO;
import com.example.demo.model.dto.DealResultDTO;
import com.example.demo.model.dto.NFTClassListDTO;
import com.example.demo.model.dto.NFTOperateDTO;
import com.example.demo.model.req.NFTClassListReq;
import com.example.demo.model.req.NFTCreateReq;
import com.example.demo.model.req.NFTPublishReq;
import com.example.demo.model.req.NFTTransferReq;
import com.example.demo.proxy.AvataProxy;
import com.example.demo.util.UUIDUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;

/**
 * @author enlai.wang 16621134798
 * @date: 2022/5/26
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class AvataProxyTest {
    @Resource
    private AvataProxy avataProxy;

    @Test
    public void testCreateAvataAccountFail() {
        System.out.println("创建账户错误示例");
        CreateAccountDTO createAccountDTO = avataProxy.createAccount("测试", "test1653568056132");
    }
    @Test
    public void testCreateAvataAccountSuccess() {
        System.out.println("创建账户正确示例");
        CreateAccountDTO createAccountDTO = avataProxy.createAccount("测试", "test" + System.currentTimeMillis());
    }

    @Test
    public void testQueryAvataAccountSuccess() {
        System.out.println("创建账户正确示例");
        CreateAccountDTO createAccountDTO = avataProxy.createAccount("测试", "test" + System.currentTimeMillis());
    }
    @Test
    public void testQueryNFTClassList() {
        System.out.println("测试NFT类别查询");
        // 请求参数
        NFTClassListReq nftClassListReq = new NFTClassListReq();
        nftClassListReq.setName("test123456");
        nftClassListReq.setLimit("10");
        NFTClassListDTO nftClassListDTO = avataProxy.queryNFTClassList(nftClassListReq);
    }

    @Test
    public void testPublishNFT() {
        System.out.println("测试NFT发行");

        NFTPublishReq nftPublishReq = new NFTPublishReq();
        nftPublishReq.setClass_id("");
        nftPublishReq.setName("test123456");
        nftPublishReq.setOperation_id("test123456");
        nftPublishReq.setRecipient("");
        NFTOperateDTO nftPublishDTO = avataProxy.publishNFT(nftPublishReq);
    }

    @Test
    public void testQueryDealResult() {
        System.out.println("测试上链交易结果查询");
//        DealResultDTO dealResultDTO = avataProxy.queryDealResult("");
        DealResultDTO dealResultDTO2 = avataProxy.queryDealResult("");

    }

    @Test
    public void testTransferNFT() {
        System.out.println("测试NFT转让");

        NFTTransferReq nftTransferReq = new NFTTransferReq();
        nftTransferReq.setClass_id("");
        nftTransferReq.setNft_id("");
        nftTransferReq.setOwner("");
        nftTransferReq.setOperation_id("test123456");
        nftTransferReq.setRecipient("");
        NFTOperateDTO nftPublishDTO = avataProxy.transferNFT(nftTransferReq);
    }

    @Test
    public void testCreateNFT() {
        NFTCreateReq nftCreateReq = new NFTCreateReq();
        nftCreateReq.setName("");
        nftCreateReq.setOwner("");
        nftCreateReq.setOperation_id("test123456");
        avataProxy.createNFT(nftCreateReq);
    }
}
